library flutter_tex;

import 'package:flutter/widgets.dart';

import 'webview/flutter_tex_webview.dart';

class TeXView extends StatefulWidget {
  final Key key;
  final String teXHTML;
  final Function(double viewHeight) onRenderFinished;
  final Function() onPageFinished;

  TeXView({this.key, this.teXHTML, this.onRenderFinished, this.onPageFinished});

  @override
  _TeXViewState createState() => _TeXViewState();
}

class _TeXViewState extends State<TeXView> with AutomaticKeepAliveClientMixin {
  String teXUrl;
  double _height = 1;

  @override
  void initState() {
    teXUrl =
        "packages/flutter_tex/MathJax/index.html?data=${Uri.encodeComponent(widget.teXHTML)}";
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return SizedBox(
      height: _height,
      child: WebView(
        key: widget.key,
        initialUrl: teXUrl,
        onPageFinished: (message) {
          if (widget.onPageFinished != null) {
            widget.onPageFinished();
          }
        },
        javascriptChannels: Set.from([
          JavascriptChannel(
              name: 'RenderedWebViewHeight',
              onMessageReceived: (JavascriptMessage message) {
                setState(() {
                  _height = double.parse(message.message)+20;
                });
                if (widget.onRenderFinished != null) {
                  widget.onRenderFinished(_height);
                }
              })
        ]),
        javascriptMode: JavascriptMode.unrestricted,
      ),
    );
  }

  @override
  bool get wantKeepAlive => true;

}
